#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <QFileDialog>
#include <QLabel>
#include <QPixmap>
#include <QTextStream>
#include "namedialog.h"

namespace Ui
{
    class MainWindowClass;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();


public slots:
    void openFile();
    void getImage (QString);
    void cropImage ();
    void installImageSet();
    void installImageSetWithName(QString);

signals:
    void installationStatusUpdate (int);
    void installationFinished ();



private:
    Ui::MainWindowClass *ui;
    QPixmap *basicImage;
    QPixmap *img_1;
    QPixmap *img_2;
    QPixmap *img_3;
    QPixmap *img_4;
    NameDialog *nameDialog;
};

#endif // MAINWINDOW_H
