#include "namedialog.h"
#include "ui_namedialog.h"
#include <QTextStream>

NameDialog::NameDialog(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::NameDialog)
{
    m_ui->setupUi(this);
    connect (m_ui->nameInput, SIGNAL (textChanged(QString)),this,SLOT (activateButton(QString)));
}

NameDialog::~NameDialog()
{
    delete m_ui;
}

void NameDialog::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void NameDialog::acceptName() {
    QTextStream out (stdout);
    out << m_ui->nameInput->text() << endl;
    emit nameEntered (m_ui->nameInput->text());
    this->close();
}


void NameDialog::activateButton(QString enteredName) {
    if (!enteredName.isEmpty()) {
        m_ui->acceptButton->setEnabled(true);
    }
    else {
        m_ui->acceptButton->setEnabled(false);
    }
}
