#include "progressdialog.h"
#include "ui_progressdialog.h"

ProgressDialog::ProgressDialog(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::ProgressDialog)
{
    m_ui->setupUi(this);
    this->setWindowTitle("Installing");
    m_ui->noticedButton->setVisible(false);
    m_ui->doneLabel->setVisible(false);
}

ProgressDialog::~ProgressDialog()
{
    delete m_ui;
}

void ProgressDialog::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}


void ProgressDialog::updateInstallationStatus(int status) {
    m_ui->progressBar->setValue(status);
}

void ProgressDialog::installationFinished () {
    m_ui->progressBar->setValue(100);
    m_ui->progressBar->setVisible(false);
    m_ui->noticedButton->setVisible(true);
    m_ui->doneLabel->setVisible(true);
}
